#include <hxcpp.h>

#ifndef INCLUDED_ApplicationMain
#include <ApplicationMain.h>
#endif
#ifndef INCLUDED_Cursor
#include <Cursor.h>
#endif
#ifndef INCLUDED_Doom
#include <Doom.h>
#endif
#ifndef INCLUDED_GameScene
#include <GameScene.h>
#endif
#ifndef INCLUDED_hxMath
#include <hxMath.h>
#endif
#ifndef INCLUDED_Std
#include <Std.h>
#endif
#ifndef INCLUDED_TitleScene
#include <TitleScene.h>
#endif
#ifndef INCLUDED_com_haxepunk_Entity
#include <com/haxepunk/Entity.h>
#endif
#ifndef INCLUDED_com_haxepunk_Graphic
#include <com/haxepunk/Graphic.h>
#endif
#ifndef INCLUDED_com_haxepunk_HXP
#include <com/haxepunk/HXP.h>
#endif
#ifndef INCLUDED_com_haxepunk_Scene
#include <com/haxepunk/Scene.h>
#endif
#ifndef INCLUDED_com_haxepunk_Screen
#include <com/haxepunk/Screen.h>
#endif
#ifndef INCLUDED_com_haxepunk_Sfx
#include <com/haxepunk/Sfx.h>
#endif
#ifndef INCLUDED_com_haxepunk_Tweener
#include <com/haxepunk/Tweener.h>
#endif
#ifndef INCLUDED_com_haxepunk_graphics_Backdrop
#include <com/haxepunk/graphics/Backdrop.h>
#endif
#ifndef INCLUDED_com_haxepunk_graphics_Canvas
#include <com/haxepunk/graphics/Canvas.h>
#endif
#ifndef INCLUDED_com_haxepunk_graphics_Image
#include <com/haxepunk/graphics/Image.h>
#endif
#ifndef INCLUDED_com_haxepunk_graphics_Text
#include <com/haxepunk/graphics/Text.h>
#endif
#ifndef INCLUDED_com_haxepunk_utils_Input
#include <com/haxepunk/utils/Input.h>
#endif
#ifndef INCLUDED_native_events_EventDispatcher
#include <native/events/EventDispatcher.h>
#endif
#ifndef INCLUDED_native_events_IEventDispatcher
#include <native/events/IEventDispatcher.h>
#endif
#ifndef INCLUDED_native_geom_Point
#include <native/geom/Point.h>
#endif
#ifndef INCLUDED_native_media_Sound
#include <native/media/Sound.h>
#endif
#ifndef INCLUDED_native_media_SoundChannel
#include <native/media/SoundChannel.h>
#endif
#ifndef INCLUDED_native_media_SoundTransform
#include <native/media/SoundTransform.h>
#endif
#ifndef INCLUDED_nme_installer_Assets
#include <nme/installer/Assets.h>
#endif
#ifndef INCLUDED_sys_FileSystem
#include <sys/FileSystem.h>
#endif
#ifndef INCLUDED_sys_io_File
#include <sys/io/File.h>
#endif

Void GameScene_obj::__construct()
{
HX_STACK_PUSH("GameScene::new","GameScene.hx",14);
{
	HX_STACK_LINE(29)
	this->deathTimer = (int)0;
	HX_STACK_LINE(28)
	this->playing = true;
	HX_STACK_LINE(27)
	this->backgroundTimer = (int)0;
	HX_STACK_LINE(25)
	this->musicTimer = (int)0;
	HX_STACK_LINE(21)
	this->scoreTime = (int)0;
	HX_STACK_LINE(19)
	this->addTime = .3;
	HX_STACK_LINE(18)
	this->addTimer = (int)0;
	HX_STACK_LINE(17)
	this->speed = (int)120;
	HX_STACK_LINE(35)
	super::__construct();
	HX_STACK_LINE(36)
	this->music = ::com::haxepunk::Sfx_obj::__new(::ApplicationMain_obj::getAsset(HX_CSTRING("sfx/Trance.wav")),null());
}
;
	return null();
}

GameScene_obj::~GameScene_obj() { }

Dynamic GameScene_obj::__CreateEmpty() { return  new GameScene_obj; }
hx::ObjectPtr< GameScene_obj > GameScene_obj::__new()
{  hx::ObjectPtr< GameScene_obj > result = new GameScene_obj();
	result->__construct();
	return result;}

Dynamic GameScene_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< GameScene_obj > result = new GameScene_obj();
	result->__construct();
	return result;}

Void GameScene_obj::lose( ){
{
		HX_STACK_PUSH("GameScene::lose","GameScene.hx",113);
		HX_STACK_THIS(this);
		HX_STACK_LINE(114)
		if (((bool((bool(::sys::FileSystem_obj::exists(HX_CSTRING("highscore.txt"))) && bool((::Math_obj::round(this->scoreTime) > ::Std_obj::parseInt(::sys::io::File_obj::getContent(HX_CSTRING("highscore.txt"))))))) || bool((::sys::FileSystem_obj::exists(HX_CSTRING("highscore.txt")) == false))))){
			HX_STACK_LINE(115)
			::sys::io::File_obj::saveContent(HX_CSTRING("highscore.txt"),::Std_obj::string(::Math_obj::round(this->scoreTime)));
		}
		HX_STACK_LINE(117)
		if (((this->deathText == null()))){
			HX_STACK_LINE(117)
			this->deathText = ::com::haxepunk::graphics::Text_obj::__new(this->deathTextArray->__get(::Math_obj::floor((::Math_obj::random() * this->deathTextArray->length))),null(),null(),null(),null(),null());
		}
		HX_STACK_LINE(118)
		this->addGraphic(this->deathText,null(),null(),null());
		HX_STACK_LINE(120)
		this->playing = false;
		HX_STACK_LINE(121)
		::Doom d;		HX_STACK_VAR(d,"d");
		HX_STACK_LINE(122)
		{
			HX_STACK_LINE(122)
			int _g = (int)0;		HX_STACK_VAR(_g,"_g");
			Array< ::Doom > _g1 = this->dooms;		HX_STACK_VAR(_g1,"_g1");
			HX_STACK_LINE(122)
			while(((_g < _g1->length))){
				HX_STACK_LINE(122)
				::Doom d1 = _g1->__get(_g);		HX_STACK_VAR(d1,"d1");
				HX_STACK_LINE(122)
				++(_g);
				HX_STACK_LINE(124)
				d1->speed = (int)0;
			}
		}
		HX_STACK_LINE(127)
		this->music->stop();
		HX_STACK_LINE(128)
		::native::media::Sound die = ::nme::installer::Assets_obj::getSound(HX_CSTRING("sfx/dead.wav"));		HX_STACK_VAR(die,"die");
		HX_STACK_LINE(129)
		die->play(null(),null(),null());
	}
return null();
}


HX_DEFINE_DYNAMIC_FUNC0(GameScene_obj,lose,(void))

Void GameScene_obj::update( ){
{
		HX_STACK_PUSH("GameScene::update","GameScene.hx",59);
		HX_STACK_THIS(this);
		HX_STACK_LINE(60)
		this->super::update();
		HX_STACK_LINE(61)
		if ((this->playing)){
			HX_STACK_LINE(63)
			if ((::com::haxepunk::utils::Input_obj::check((int)27))){
				HX_STACK_LINE(63)
				::com::haxepunk::HXP_obj::set_scene(::TitleScene_obj::__new());
			}
			HX_STACK_LINE(64)
			hx::AddEq(this->backgroundTimer,::com::haxepunk::HXP_obj::elapsed);
			HX_STACK_LINE(66)
			if (((this->backgroundTimer >= (int)1))){
				HX_STACK_LINE(68)
				this->backgroundTimer = (int)0;
				struct _Function_3_1{
					inline static Float Block( ){
						HX_STACK_PUSH("*::closure","GameScene.hx",69);
						{
							HX_STACK_LINE(69)
							::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
							HX_STACK_LINE(69)
							return (Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646));
						}
						return null();
					}
				};
				HX_STACK_LINE(69)
				this->background->set_color(::Math_obj::round((_Function_3_1::Block() * (int)16777215)));
				HX_STACK_LINE(70)
				while(((this->background->get_color() <= (int)50))){
					struct _Function_4_1{
						inline static Float Block( ){
							HX_STACK_PUSH("*::closure","GameScene.hx",70);
							{
								HX_STACK_LINE(70)
								::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
								HX_STACK_LINE(70)
								return (Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646));
							}
							return null();
						}
					};
					HX_STACK_LINE(70)
					this->background->set_color(::Math_obj::round((_Function_4_1::Block() * (int)16777215)));
				}
				HX_STACK_LINE(71)
				::com::haxepunk::HXP_obj::screen->set_scale((int)1);
			}
			HX_STACK_LINE(73)
			hx::AddEq(this->musicTimer,::com::haxepunk::HXP_obj::elapsed);
			HX_STACK_LINE(74)
			if (((this->musicTimer >= (int)16))){
				HX_STACK_LINE(76)
				this->musicTimer = (int)0;
				HX_STACK_LINE(77)
				this->music->play(null(),null());
			}
			HX_STACK_LINE(79)
			hx::AddEq(this->addTimer,::com::haxepunk::HXP_obj::elapsed);
			HX_STACK_LINE(80)
			if (((this->addTimer >= this->addTime))){
				struct _Function_3_1{
					inline static int Block( ){
						HX_STACK_PUSH("*::closure","GameScene.hx",82);
						{
							HX_STACK_LINE(82)
							::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
							HX_STACK_LINE(82)
							return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * ((::com::haxepunk::HXP_obj::screen->width - (int)100))));
						}
						return null();
					}
				};
				HX_STACK_LINE(82)
				this->dooms->push(this->create(hx::ClassOf< ::Doom >(),null())->__Field(HX_CSTRING("init"),true)(_Function_3_1::Block()));
				HX_STACK_LINE(83)
				this->addTimer = (int)0;
			}
			HX_STACK_LINE(86)
			hx::AddEq(this->scoreTime,::com::haxepunk::HXP_obj::elapsed);
			HX_STACK_LINE(87)
			if (((this->scoreText != null()))){
				HX_STACK_LINE(87)
				this->scoreText->set_text(::Std_obj::string(::Math_obj::floor(this->scoreTime)));
			}
			HX_STACK_LINE(88)
			hx::AddEq(this->speed,(int)1);
			HX_STACK_LINE(89)
			if (((this->speed >= (int)1000))){
				HX_STACK_LINE(89)
				this->speed = (int)1000;
			}
			HX_STACK_LINE(90)
			hx::SubEq(this->addTime,.0003);
			HX_STACK_LINE(91)
			if (((this->addTime <= .07))){
				HX_STACK_LINE(91)
				this->addTime = .07;
			}
			HX_STACK_LINE(92)
			::Doom d;		HX_STACK_VAR(d,"d");
			HX_STACK_LINE(93)
			{
				HX_STACK_LINE(93)
				int _g = (int)0;		HX_STACK_VAR(_g,"_g");
				Array< ::Doom > _g1 = this->dooms;		HX_STACK_VAR(_g1,"_g1");
				HX_STACK_LINE(93)
				while(((_g < _g1->length))){
					HX_STACK_LINE(93)
					::Doom d1 = _g1->__get(_g);		HX_STACK_VAR(d1,"d1");
					HX_STACK_LINE(93)
					++(_g);
					HX_STACK_LINE(95)
					d1->speed = this->speed;
				}
			}
		}
		else{
			struct _Function_2_1{
				inline static int Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",100);
					{
						HX_STACK_LINE(100)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(100)
						return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * (int)20));
					}
					return null();
				}
			};
			HX_STACK_LINE(100)
			hx::AddEq(::com::haxepunk::HXP_obj::camera->x,(_Function_2_1::Block() - (int)10));
			struct _Function_2_2{
				inline static int Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",101);
					{
						HX_STACK_LINE(101)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(101)
						return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * (int)20));
					}
					return null();
				}
			};
			HX_STACK_LINE(101)
			hx::AddEq(::com::haxepunk::HXP_obj::camera->y,(_Function_2_2::Block() - (int)10));
			struct _Function_2_3{
				inline static Float Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",102);
					{
						HX_STACK_LINE(102)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(102)
						return (Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646));
					}
					return null();
				}
			};
			HX_STACK_LINE(102)
			this->background->set_color(::Math_obj::round((_Function_2_3::Block() * (int)16777215)));
			HX_STACK_LINE(103)
			hx::AddEq(this->deathTimer,::com::haxepunk::HXP_obj::elapsed);
			struct _Function_2_4{
				inline static int Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",104);
					{
						HX_STACK_LINE(104)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(104)
						return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * (int)256));
					}
					return null();
				}
			};
			HX_STACK_LINE(104)
			this->deathText->set_size(_Function_2_4::Block());
			struct _Function_2_5{
				inline static int Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",105);
					{
						HX_STACK_LINE(105)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(105)
						return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * ::com::haxepunk::HXP_obj::screen->width));
					}
					return null();
				}
			};
			HX_STACK_LINE(105)
			this->deathText->x = _Function_2_5::Block();
			struct _Function_2_6{
				inline static int Block( ){
					HX_STACK_PUSH("*::closure","GameScene.hx",106);
					{
						HX_STACK_LINE(106)
						::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
						HX_STACK_LINE(106)
						return ::Std_obj::_int(((Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646)) * ::com::haxepunk::HXP_obj::screen->height));
					}
					return null();
				}
			};
			HX_STACK_LINE(106)
			this->deathText->y = _Function_2_6::Block();
			HX_STACK_LINE(108)
			if (((this->deathTimer >= (int)1))){
				HX_STACK_LINE(108)
				::com::haxepunk::HXP_obj::set_scene(::TitleScene_obj::__new());
			}
		}
	}
return null();
}


Void GameScene_obj::begin( ){
{
		HX_STACK_PUSH("GameScene::begin","GameScene.hx",40);
		HX_STACK_THIS(this);
		HX_STACK_LINE(41)
		this->add(::Cursor_obj::__new());
		HX_STACK_LINE(42)
		this->scoreText = ::com::haxepunk::graphics::Text_obj::__new(HX_CSTRING("Hi"),null(),null(),null(),null(),null());
		HX_STACK_LINE(43)
		this->scoreText->set_size((int)64);
		HX_STACK_LINE(44)
		this->scoreText->set_layer((int)-200);
		HX_STACK_LINE(45)
		this->scoreText->x = (int)10;
		HX_STACK_LINE(46)
		this->scoreText->y = (int)10;
		HX_STACK_LINE(48)
		this->addGraphic(this->scoreText,null(),null(),null());
		HX_STACK_LINE(49)
		this->dooms = Array_obj< ::Doom >::__new();
		HX_STACK_LINE(50)
		this->music->play(null(),null());
		HX_STACK_LINE(51)
		this->background = ::com::haxepunk::graphics::Backdrop_obj::__new(HX_CSTRING("gfx/Background.png"),null(),null());
		struct _Function_1_1{
			inline static Float Block( ){
				HX_STACK_PUSH("*::closure","GameScene.hx",52);
				{
					HX_STACK_LINE(52)
					::com::haxepunk::HXP_obj::_seed = ::Std_obj::_int(hx::Mod((::com::haxepunk::HXP_obj::_seed * 16807.0),(int)2147483646));
					HX_STACK_LINE(52)
					return (Float(::com::haxepunk::HXP_obj::_seed) / Float((int)2147483646));
				}
				return null();
			}
		};
		HX_STACK_LINE(52)
		this->background->set_color(::Math_obj::round((_Function_1_1::Block() * (int)16777215)));
		HX_STACK_LINE(53)
		this->background->set_layer((int)400);
		HX_STACK_LINE(54)
		this->addGraphic(this->background,null(),null(),null());
		HX_STACK_LINE(55)
		this->deathTextArray = Array_obj< ::String >::__new().Add(HX_CSTRING("DEATH")).Add(HX_CSTRING("YOU HAVE FAILED")).Add(HX_CSTRING("THE END")).Add(HX_CSTRING("YOU LOSE")).Add(HX_CSTRING("YOU WIN")).Add(HX_CSTRING("THANKS FOR PLAYING")).Add(HX_CSTRING("WINNERS DON'T USE DRUGS")).Add(HX_CSTRING("MISSION FAILED")).Add(HX_CSTRING("TRY AGAIN")).Add(HX_CSTRING("GAME OVER"));
	}
return null();
}



GameScene_obj::GameScene_obj()
{
}

void GameScene_obj::__Mark(HX_MARK_PARAMS)
{
	HX_MARK_BEGIN_CLASS(GameScene);
	HX_MARK_MEMBER_NAME(deathText,"deathText");
	HX_MARK_MEMBER_NAME(deathTextArray,"deathTextArray");
	HX_MARK_MEMBER_NAME(deathTimer,"deathTimer");
	HX_MARK_MEMBER_NAME(playing,"playing");
	HX_MARK_MEMBER_NAME(backgroundTimer,"backgroundTimer");
	HX_MARK_MEMBER_NAME(background,"background");
	HX_MARK_MEMBER_NAME(musicTimer,"musicTimer");
	HX_MARK_MEMBER_NAME(music,"music");
	HX_MARK_MEMBER_NAME(cursorX,"cursorX");
	HX_MARK_MEMBER_NAME(dooms,"dooms");
	HX_MARK_MEMBER_NAME(scoreTime,"scoreTime");
	HX_MARK_MEMBER_NAME(scoreText,"scoreText");
	HX_MARK_MEMBER_NAME(addTime,"addTime");
	HX_MARK_MEMBER_NAME(addTimer,"addTimer");
	HX_MARK_MEMBER_NAME(speed,"speed");
	HX_MARK_MEMBER_NAME(cursor,"cursor");
	super::__Mark(HX_MARK_ARG);
	HX_MARK_END_CLASS();
}

void GameScene_obj::__Visit(HX_VISIT_PARAMS)
{
	HX_VISIT_MEMBER_NAME(deathText,"deathText");
	HX_VISIT_MEMBER_NAME(deathTextArray,"deathTextArray");
	HX_VISIT_MEMBER_NAME(deathTimer,"deathTimer");
	HX_VISIT_MEMBER_NAME(playing,"playing");
	HX_VISIT_MEMBER_NAME(backgroundTimer,"backgroundTimer");
	HX_VISIT_MEMBER_NAME(background,"background");
	HX_VISIT_MEMBER_NAME(musicTimer,"musicTimer");
	HX_VISIT_MEMBER_NAME(music,"music");
	HX_VISIT_MEMBER_NAME(cursorX,"cursorX");
	HX_VISIT_MEMBER_NAME(dooms,"dooms");
	HX_VISIT_MEMBER_NAME(scoreTime,"scoreTime");
	HX_VISIT_MEMBER_NAME(scoreText,"scoreText");
	HX_VISIT_MEMBER_NAME(addTime,"addTime");
	HX_VISIT_MEMBER_NAME(addTimer,"addTimer");
	HX_VISIT_MEMBER_NAME(speed,"speed");
	HX_VISIT_MEMBER_NAME(cursor,"cursor");
	super::__Visit(HX_VISIT_ARG);
}

Dynamic GameScene_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 4:
		if (HX_FIELD_EQ(inName,"lose") ) { return lose_dyn(); }
		break;
	case 5:
		if (HX_FIELD_EQ(inName,"begin") ) { return begin_dyn(); }
		if (HX_FIELD_EQ(inName,"music") ) { return music; }
		if (HX_FIELD_EQ(inName,"dooms") ) { return dooms; }
		if (HX_FIELD_EQ(inName,"speed") ) { return speed; }
		break;
	case 6:
		if (HX_FIELD_EQ(inName,"update") ) { return update_dyn(); }
		if (HX_FIELD_EQ(inName,"cursor") ) { return cursor; }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"playing") ) { return playing; }
		if (HX_FIELD_EQ(inName,"cursorX") ) { return cursorX; }
		if (HX_FIELD_EQ(inName,"addTime") ) { return addTime; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"addTimer") ) { return addTimer; }
		break;
	case 9:
		if (HX_FIELD_EQ(inName,"deathText") ) { return deathText; }
		if (HX_FIELD_EQ(inName,"scoreTime") ) { return scoreTime; }
		if (HX_FIELD_EQ(inName,"scoreText") ) { return scoreText; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"deathTimer") ) { return deathTimer; }
		if (HX_FIELD_EQ(inName,"background") ) { return background; }
		if (HX_FIELD_EQ(inName,"musicTimer") ) { return musicTimer; }
		break;
	case 14:
		if (HX_FIELD_EQ(inName,"deathTextArray") ) { return deathTextArray; }
		break;
	case 15:
		if (HX_FIELD_EQ(inName,"backgroundTimer") ) { return backgroundTimer; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic GameScene_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"music") ) { music=inValue.Cast< ::com::haxepunk::Sfx >(); return inValue; }
		if (HX_FIELD_EQ(inName,"dooms") ) { dooms=inValue.Cast< Array< ::Doom > >(); return inValue; }
		if (HX_FIELD_EQ(inName,"speed") ) { speed=inValue.Cast< Float >(); return inValue; }
		break;
	case 6:
		if (HX_FIELD_EQ(inName,"cursor") ) { cursor=inValue.Cast< ::com::haxepunk::Entity >(); return inValue; }
		break;
	case 7:
		if (HX_FIELD_EQ(inName,"playing") ) { playing=inValue.Cast< bool >(); return inValue; }
		if (HX_FIELD_EQ(inName,"cursorX") ) { cursorX=inValue.Cast< Float >(); return inValue; }
		if (HX_FIELD_EQ(inName,"addTime") ) { addTime=inValue.Cast< Float >(); return inValue; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"addTimer") ) { addTimer=inValue.Cast< Float >(); return inValue; }
		break;
	case 9:
		if (HX_FIELD_EQ(inName,"deathText") ) { deathText=inValue.Cast< ::com::haxepunk::graphics::Text >(); return inValue; }
		if (HX_FIELD_EQ(inName,"scoreTime") ) { scoreTime=inValue.Cast< Float >(); return inValue; }
		if (HX_FIELD_EQ(inName,"scoreText") ) { scoreText=inValue.Cast< ::com::haxepunk::graphics::Text >(); return inValue; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"deathTimer") ) { deathTimer=inValue.Cast< Float >(); return inValue; }
		if (HX_FIELD_EQ(inName,"background") ) { background=inValue.Cast< ::com::haxepunk::graphics::Backdrop >(); return inValue; }
		if (HX_FIELD_EQ(inName,"musicTimer") ) { musicTimer=inValue.Cast< Float >(); return inValue; }
		break;
	case 14:
		if (HX_FIELD_EQ(inName,"deathTextArray") ) { deathTextArray=inValue.Cast< Array< ::String > >(); return inValue; }
		break;
	case 15:
		if (HX_FIELD_EQ(inName,"backgroundTimer") ) { backgroundTimer=inValue.Cast< Float >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void GameScene_obj::__GetFields(Array< ::String> &outFields)
{
	outFields->push(HX_CSTRING("deathText"));
	outFields->push(HX_CSTRING("deathTextArray"));
	outFields->push(HX_CSTRING("deathTimer"));
	outFields->push(HX_CSTRING("playing"));
	outFields->push(HX_CSTRING("backgroundTimer"));
	outFields->push(HX_CSTRING("background"));
	outFields->push(HX_CSTRING("musicTimer"));
	outFields->push(HX_CSTRING("music"));
	outFields->push(HX_CSTRING("cursorX"));
	outFields->push(HX_CSTRING("dooms"));
	outFields->push(HX_CSTRING("scoreTime"));
	outFields->push(HX_CSTRING("scoreText"));
	outFields->push(HX_CSTRING("addTime"));
	outFields->push(HX_CSTRING("addTimer"));
	outFields->push(HX_CSTRING("speed"));
	outFields->push(HX_CSTRING("cursor"));
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	String(null()) };

static ::String sMemberFields[] = {
	HX_CSTRING("lose"),
	HX_CSTRING("update"),
	HX_CSTRING("begin"),
	HX_CSTRING("deathText"),
	HX_CSTRING("deathTextArray"),
	HX_CSTRING("deathTimer"),
	HX_CSTRING("playing"),
	HX_CSTRING("backgroundTimer"),
	HX_CSTRING("background"),
	HX_CSTRING("musicTimer"),
	HX_CSTRING("music"),
	HX_CSTRING("cursorX"),
	HX_CSTRING("dooms"),
	HX_CSTRING("scoreTime"),
	HX_CSTRING("scoreText"),
	HX_CSTRING("addTime"),
	HX_CSTRING("addTimer"),
	HX_CSTRING("speed"),
	HX_CSTRING("cursor"),
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(GameScene_obj::__mClass,"__mClass");
};

static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(GameScene_obj::__mClass,"__mClass");
};

Class GameScene_obj::__mClass;

void GameScene_obj::__register()
{
	Static(__mClass) = hx::RegisterClass(HX_CSTRING("GameScene"), hx::TCanCast< GameScene_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics, sVisitStatics);
}

void GameScene_obj::__boot()
{
}

