class ApplicationMain
{

	#if waxe
	static public var frame : wx.Frame;
	static public var autoShowFrame : Bool = true;
	#if nme
	static public var nmeStage : wx.NMEStage;
	#end
	#end
	
	public static function main()
	{
		#if nme
		nme.Lib.setPackage("", "FvOOM", "com.example.app", "1.0.0");
		
		#end
		
		#if waxe
		wx.App.boot(function()
		{
			
			frame = wx.Frame.create(null, null, "FvOOM", null, { width: 1280, height: 800 });
			
			#if nme
			var stage = wx.NMEStage.create(frame, null, null, { width: 1280, height: 800 });
			#end
			
			Main.main();
			
			if (autoShowFrame)
			{
				wx.App.setTopWindow(frame);
				frame.shown = true;
			}
		});
		#else
		
		nme.Lib.create(function()
			{ 
				//if ((1280 == 0 && 800 == 0) || false)
				//{
					nme.Lib.current.stage.align = nme.display.StageAlign.TOP_LEFT;
					nme.Lib.current.stage.scaleMode = nme.display.StageScaleMode.NO_SCALE;
				//}
				
				var hasMain = false;
				
				for (methodName in Type.getClassFields(Main))
				{
					if (methodName == "main")
					{
						hasMain = true;
						break;
					}
				}
				
				if (hasMain)
				{
					Reflect.callMethod (Main, Reflect.field (Main, "main"), []);
				}
				else
				{
					var instance = Type.createInstance(Main, []);
					#if nme
					if (Std.is (instance, nme.display.DisplayObject)) {
						nme.Lib.current.addChild(cast instance);
					}
					#end
				}
			},
			1280, 800, 
			60, 
			0,
			(true ? nme.Lib.HARDWARE : 0) |
			(false ? nme.Lib.ALLOW_SHADERS : 0) |
			(false ? nme.Lib.REQUIRE_SHADERS : 0) |
			(false ? nme.Lib.DEPTH_BUFFER : 0) |
			(false ? nme.Lib.STENCIL_BUFFER : 0) |
			(true ? nme.Lib.RESIZABLE : 0) |
			(false ? nme.Lib.BORDERLESS : 0) |
			(false ? nme.Lib.VSYNC : 0) |
			(false ? nme.Lib.FULLSCREEN : 0) |
			(0 == 4 ? nme.Lib.HW_AA_HIRES : 0) |
			(0 == 2 ? nme.Lib.HW_AA : 0),
			"FvOOM"
			
		);
		#end
		
	}
	
	
	#if neko
	public static function __init__ () {
		
		untyped $loader.path = $array ("@executable_path/", $loader.path);
		
	}
	#end
	
	
	public static function getAsset(inName:String):Dynamic
	{
		#if nme
		
		if (inName == "gfx/debug/console_debug.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_debug.png");
			
		}
		
		if (inName == "gfx/debug/console_logo.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_logo.png");
			
		}
		
		if (inName == "gfx/debug/console_output.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_output.png");
			
		}
		
		if (inName == "gfx/debug/console_pause.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_pause.png");
			
		}
		
		if (inName == "gfx/debug/console_play.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_play.png");
			
		}
		
		if (inName == "gfx/debug/console_step.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/debug/console_step.png");
			
		}
		
		if (inName == "gfx/preloader/haxepunk.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/preloader/haxepunk.png");
			
		}
		
		if (inName == "font/04B_03__.ttf")
		{
			
			return nme.Assets.getFont ("font/04B_03__.ttf");
			
		}
		
		if (inName == "gfx/Background.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Background.png");
			
		}
		
		if (inName == "gfx/Cursor.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Cursor.png");
			
		}
		
		if (inName == "gfx/Doom.png")
		{
			
			return nme.Assets.getBitmapData ("gfx/Doom.png");
			
		}
		
		if (inName == "sfx/dead.wav")
		{
			
			return nme.Assets.getSound ("sfx/dead.wav");
			
		}
		
		if (inName == "sfx/Trance.wav")
		{
			
			return nme.Assets.getSound ("sfx/Trance.wav");
			
		}
		
		#end
		return null;
	}
	
	
}
