import com.haxepunk.Scene;
import com.haxepunk.HXP;
import com.haxepunk.utils.Input;
import com.haxepunk.utils.Key;
import com.haxepunk.graphics.Text;
import com.haxepunk.graphics.Image;
import com.haxepunk.Entity;
import com.haxepunk.Sfx;
import com.haxepunk.graphics.Backdrop;
import sys.io.File;
import nme.Assets;
import com.haxepunk.graphics.Text;

class GameScene extends Scene
{
	var cursor:Entity;
	var speed:Float = 120;
	var addTimer:Float = 0;
	var addTime:Float = .3;
	var scoreText:Text;
	var scoreTime:Float = 0;
	var dooms:Array<Doom>;
	public var cursorX:Float;
	var music:Sfx;
	var musicTimer:Float = 0;
	var background:Backdrop;
	var backgroundTimer:Float = 0;
	var playing:Bool = true;
	var deathTimer:Float = 0;
	var deathTextArray:Array<String>;
	var deathText:Text;

	public function new()
	{
		super();
		music = new Sfx(ApplicationMain.getAsset("sfx/Trance.wav"));
	}

	override public function begin()
	{
		add(new Cursor());
		scoreText = new Text("Hi");
		scoreText.size = 64;
		scoreText.layer = -200;
		scoreText.x = 10;
		scoreText.y = 10;
		//scoreText.color = 0xC48930;
		addGraphic(scoreText);
		dooms = new Array();
		music.play();
		background = new Backdrop("gfx/Background.png");
		background.color = Math.round(HXP.random * 0xFFFFFF);
		background.layer = 400;
		addGraphic(background);
		deathTextArray =["DEATH","YOU HAVE FAILED","THE END","YOU LOSE","YOU WIN","THANKS FOR PLAYING","WINNERS DON'T USE DRUGS","MISSION FAILED","TRY AGAIN","GAME OVER"];
	}

	override public function update()
	{
		super.update();
		if (playing)
		{
			if (Input.check(Key.ESCAPE)) HXP.scene = new TitleScene();
			backgroundTimer += HXP.elapsed;
			//HXP.screen.scale -= .003;
			if (backgroundTimer >= 1) 
			{	
				backgroundTimer = 0;
				background.color = Math.round(HXP.random * 0xFFFFFF);
				while (background.color <= 50) background.color = Math.round(HXP.random * 0xFFFFFF);
				HXP.screen.scale = 1;
			}
			musicTimer += HXP.elapsed;
			if (musicTimer >= 16)
			{
				musicTimer = 0;
				music.play();
			}
			addTimer += HXP.elapsed;
			if (addTimer >= addTime)
			{
				dooms.push(create(Doom).init(HXP.rand(HXP.screen.width - 100)));
				addTimer = 0;
			}

			scoreTime += HXP.elapsed;
			if (scoreText != null) scoreText.text = Std.string(Math.floor(scoreTime));
			speed += 1;
			if (speed >= 1000) speed = 1000;
			addTime -= .0003;
			if (addTime <= .07) addTime = .07;
			var d:Doom;
			for (d in dooms)
			{
				d.speed = speed;
			}
		}
		else
		{
			HXP.camera.x += HXP.rand(20) - 10;
			HXP.camera.y += HXP.rand(20) - 10;
			background.color = Math.round(HXP.random * 0xFFFFFF);
			deathTimer += HXP.elapsed;
			deathText.size = HXP.rand(256);
			deathText.x = HXP.rand(HXP.screen.width);
			deathText.y = HXP.rand(HXP.screen.height);

			if (deathTimer >= 1) HXP.scene = new TitleScene();
		}
	}

	public function lose()
	{
		if (sys.FileSystem.exists("highscore.txt") && Math.round(scoreTime) > Std.parseInt(File.getContent(("highscore.txt"))) || sys.FileSystem.exists("highscore.txt") == false)
		File.saveContent("highscore.txt", Std.string(Math.round(scoreTime)));

		if (deathText == null) deathText = new Text(deathTextArray[Math.floor(Math.random() * deathTextArray.length)]);
		addGraphic(deathText);

		playing = false;
		var d:Doom;
		for (d in dooms)
		{
			d.speed = 0;
		}

		music.stop();
		var die = (Assets.getSound("sfx/dead.wav"));
		die.play();
	}

}