import com.haxepunk.Scene;
import com.haxepunk.graphics.Image;
import com.haxepunk.graphics.Text;
import com.haxepunk.HXP;
import com.haxepunk.graphics.Backdrop;
import com.haxepunk.utils.Input;
import com.haxepunk.utils.Key;
import sys.io.File;

class TitleScene extends Scene
{

	var background:Backdrop;
	var titleText:Text;
	var startText:Text;
	var highScoreText:Text;

	public function new()
	{
		super();
		titleText = new Text("FvOOM");
		startText = new Text("Click to start");
		titleText.resizable = true;
		titleText.x = HXP.screen.width / 2 - 190;
		titleText.y = 200;
		titleText.size = 128;
		startText.resizable = true;
		startText.x = (HXP.screen.width / 2) - 109;
		startText.y = 400;
		startText.size = 32;
		addGraphic(titleText);
		addGraphic(startText);
		background = new Backdrop("gfx/Background.png");
		background.color = Math.round(HXP.random * 0xFFFFFF);
		background.layer = 400;
		addGraphic(background);
		if (sys.FileSystem.exists("highscore.txt")) highScoreText =  new Text("High Score: " + Std.string(File.getContent("highscore.txt")));
		else highScoreText =  new Text("High Score: 0");
		highScoreText.y = 500;
		highScoreText.size = 32;
		highScoreText.x = (HXP.screen.width / 2) - 120;
		addGraphic(highScoreText);
	}

	override public function update()
	{
		background.color = Math.round(HXP.random * 0xFFFFFF);
		titleText.x += HXP.rand(10) - 4.5;
		titleText.y += HXP.rand(10) - 4.5;
		startText.x += HXP.rand(10) - 4.5;
		startText.y += HXP.rand(10) - 4.5;
		highScoreText.y += HXP.rand(10) - 4.5;
		highScoreText.x += HXP.rand(10) - 4.5;
		if (Input.mouseReleased) HXP.scene = new GameScene();
		if (Input.check(Key.ESCAPE)) nme.system.System.exit(0);
	}
}